package eu.hsrw.tr.prog.vl.methoden;

/**
 * Demonstration der Abläufe beim Methodenaufruf Mit Debugger ausführen und
 * Variable beobachten.
 * 
 * @author Thomas Richter
 *
 */
public class Methodenaufruf {

	// Methode zur Berechnung des Produkts a * b
	// Sehr umständlich! Nur zur Illustration.
	public static int produkt(int a, int b) {
		int ergebnis = a * b;

		return ergebnis;
	}

	// Methode zur Berechnung der Fakultät einer Ganzzahl n
	public static int fakultaet(int n) {
		// Zwischenergebnis
		int f = 1;

		for (int i = 1; i <= n; i++) {
			f = produkt(f, i);
		}

		// Rückgabe des Ergebnisses an den Aufrufer
		return f;
	}

	// Die Methode soll feststellen, ob die übergebene Zahl n die Ziffer 3
	// enthält
	// falls ja soll die Methode true zurückgeben, sonst false
	public static boolean enthaeltDrei(int n) {

		// Durchlaufe die gesamte Zahl bis nichts mehr von ihr übrig ist
		while (n > 0) {

			// ist die letzte Ziffer eine 3?
			if (n % 10 == 3) {

				// wir haben festgestellt, dass eine 3 enthalten ist
				// ==> geben true zurück, die Methode endet sofort
				return true;
			}

			// Schneide letzte Ziffer ab
			// Merke: hier wird der Parameter n geändert, dies hat aber nur
			// lokale Auswirkungen innerhalb der Methode (call-by-value)
			n = n / 10;
		}

		// gesamte Zahl wurde geprüft, der Programmablauf ist bis hierhin
		// gekommen
		// es kann also keine 3 enthalten gewesen sein, da die Methode sonst
		// schon verlassen worden wäre ==> keine 3 in n enthalten
		return false;
	}

	public static void main(String[] args) {

		int x = 2;

		int y = 4;

		int p = produkt(x, y);

		System.out.println(p);

		System.out.println(fakultaet(y));
		
		int a = 446671;
		System.out.println("enhält 3: " + enthaeltDrei(a));

		a = 4346671;
		System.out.println("enhält 3: " + enthaeltDrei(a));
	}
}